Attribute VB_Name = "Module1"

'S-100 MCA declarations
Public Type timeb
 time As Long
 millitm As Integer
 timezone As Integer
 dstflag As Integer
End Type

Public Type elap
  livetime As Long
  truetime As Long
  sweeps As Long
  comp As Double
End Type

 Public Type xcal
 ecal2 As Single
 ecal1 As Single
 ecal0 As Single
 unitname As String * 5
 unittype As String * 1
 cformat As String * 1
 corder As String * 1
End Type

Public Type mcahead
 readtype As Integer
 mcanumber As Integer
 readregion As Integer
 tagno As Long
 spectrname As String * 26
 acqumode As Integer
 acqstart As timeb
 elapsed As elap
 cal As xcal
 filler(18) As Integer
 nchans As Integer
 End Type
 
Public MCAFile As String
Public nchannels As Integer
Public spectrum() As Long
Public tz As Integer
Public CAMFile As New CanberraDataAccessLib.DataAccess
Public Sub LoadSpectrum()
    Dim a As Variant, i As Integer
    On Error GoTo ErrHdlr
    
    a = CAMFile.spectrum()
    nchannels = Min(UBound(a) + 1, 16384)
    ReDim spectrum(1 To nchannels) As Long
    
    For i = 0 To nchannels - 1
    spectrum(i + 1) = CLng(a(i))
    Next i
    
    'Cleanup

    Exit Sub
    
ErrHdlr:
    If (Err.Number = cdlCancel) Then
        Exit Sub 'User clicked cancel on the dialog
    Else
        MsgBox Err.Description
    End If
End Sub

Public Sub MakeMCA()
On Error GoTo hiba
Dim head As mcahead
Dim count As Long
Dim i As Integer
Dim drive As String, dir As String, fname As String, ext As String * 4
'--------Spectrum name--------
Call SplitPath(Command, drive, dir, fname, ext)
head.spectrname = fname + ext
'Right(CAMFile.CurrentDataSourceName, 26)
'--------Acq. start-----------
'Do While Not Left(TXTLine, 18) = "Acquisition Start:"
'Line Input #1, TXTLine
'Loop
d = CAMFile.Param(CAM_X_ASTIME) 'Format(Left(TXTLine, 10), "m/d/yy", vbMonday, vbFirstJan1)
't = Format(Mid(TXTLine, 11, 9), "hh:mm:ss", vbMonday, vbFirstJan1)
d = CDate(d) + tz / 24
't = CDate(t)
s = DateDiff("s", #1/1/1970#, d, vbMonday, vbFirstJan1)
's = s + DateDiff("s", #12:00:00 AM#, t, vbMonday, vbFirstJan1)
'Close #1
head.acqstart.time = s
head.acqstart.millitm = 0
'--------Live Time------------
head.elapsed.livetime = 100 * CDbl(CAMFile.Param(CAM_X_ELIVE))
'--------True Time------------
head.elapsed.truetime = 100 * CDbl(CAMFile.Param(CAM_X_EREAL))
'-----Energy Calibration----
head.cal.corder = 1
head.cal.ecal0 = CDbl(CAMFile.Param(CAM_F_ECOFFSET))
head.cal.ecal1 = CDbl(CAMFile.Param(CAM_F_ECSLOPE))
head.cal.ecal2 = CDbl(CAMFile.Param(CAM_F_ECQUAD))
'-----Spectrum Data---------
'see as LoadSpectrum
head.nchans = nchannels

'------Write out MCA------
Open MCAFile For Binary As #1
Put #1, 1, head
Put #1, , spectrum
Close #1
Exit Sub
hiba:
 MsgBox "File Opening error: " & Err.Description, vbOKOnly + vbCritical, "File Opening Error"

End Sub


Public Sub SplitPath(ByVal Path As String, ByRef drive As String, ByRef SubDir As String, ByRef FileName As String, ByRef Suffix As String)
Dim LastBracket As String
Const BS = "\"
drive = Left(Path, 3)
LastBracket = LastCharacter(Path, BS)
SubDir = Mid(Path, 4, LastBracket - 4)
FileName = Mid(Path, LastBracket, Len(Path) - LastBracket - 3)
Suffix = Right(Path, 4)
End Sub

Public Function LastCharacter(ByVal SearchString As String, ByVal SearchFor As String) As Long
Dim CurrentPos As Integer, NextPos As Integer
NextPos = 0
Do
CurrentPos = NextPos
NextPos = InStr(CurrentPos + 1, SearchString, SearchFor)
Loop Until NextPos = 0
LastCharacter = CurrentPos + 1
End Function


