Attribute VB_Name = "Module2"
Public Const MAX_PATH = 260
Public Const gintmax_size = 144
Public CancelAccess As Boolean

Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFilename As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFilename As String) As Long
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFilename As String) As Long
Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFilename As String) As Long
Declare Function GetPrivateProfileSectionNames Lib "kernel32" Alias "GetPrivateProfileSectionNamesA" (ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFilename As String) As Long

Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Declare Function GetCurrentDirectory Lib "kernel32" Alias "GetCurrentDirectoryA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Declare Function SetCurrentDirectory Lib "kernel32" Alias "SetCurrentDirectoryA" (ByVal lpPathName As String) As Long
Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

'-----------------------------------------------------------
' FUNCTION: ReadIniFile
'
' Reads a value from the specified section/key of the
' specified .INI file
'
' IN: [strIniFile] - name of .INI file to read
'     [strSection] - section where key is found
'     [strKey] - name of key to get the value of
'
' Returns: non-zero terminated value of .INI file key
'-----------------------------------------------------------
'
Public Function ReadIniFile(ByVal strIniFile As String, ByVal strSection As String, ByVal strKey As String) As String
Dim strpuffer As String
Dim intPos As Integer
Const gintmax_size = 144
Const strnull = ""
    'If successful read of .INI file, strip any trailing zero returned by the Windows API GetPrivateProfileString
strpuffer = Space$(gintmax_size)
If GetPrivateProfileString(strSection, strKey, strnull, strpuffer, gintmax_size, strIniFile) > 0 Then
ReadIniFile = RTrim$(StripTerminator(strpuffer))
Else
ReadIniFile = strnull
End If
End Function

Public Function WriteIniFile(ByVal strIniFile As String, ByVal strSection As String, ByVal strKey As String, ByVal strValue As String) As Boolean
Dim strpuffer As String
Dim intPos As Integer
Const gintmax_size = 144
Const strnull = ""
strpuffer = Space$(gintmax_size)
If WritePrivateProfileString(strSection, strKey, strValue, strIniFile) > 0 Then
WriteIniFile = True
Else
WriteIniFile = False
End If
End Function

'-----------------------------------------------------------
' FUNCTION: StripTerminator
'
' Returns a string without any zero terminator.  Typically,
' this was a string returned by a Windows API call.
'
' IN: [strString] - String to remove terminator from
'
' Returns: The value of the string passed in minus any
'          terminating zero.
'-----------------------------------------------------------
'

Public Function StripTerminator(ByVal strString As String) As String
Dim intzeroPos As Integer
intzeroPos = InStr(strString, Chr$(0))
If intzeroPos > 0 Then
StripTerminator = Left$(strString, intzeroPos - 1)
Else
StripTerminator = strString
End If
End Function


Public Function Min(a As Variant, b As Variant) As Variant
If a < b Then Min = a
If a > b Then Min = b
If a = b Then Min = a
End Function
